import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.JOptionPane;
import javax.media.j3d.*;


/**
 * This class creates the GUI in which the virtual robot is visible. It also
 * shows the camera and robot controls. Please note that a part of this class
 * has been automatically generated by Netbeans. For your comfort, use the 
 * CyclopGui.form supplies in this directory to edit the GUI in Netbeans/Forte.
 *
 * @author Dieter Van Uytvanck
 * @version 0.1
 */
public class CyclopGui extends javax.swing.JFrame {
    
    private Cyclop refCyclop;
    private static final int DECNR = 4;
    private static final Cursor handCursor = new Cursor(Cursor.HAND_CURSOR);
    private static final Cursor defaultCursor = new Cursor(Cursor.DEFAULT_CURSOR);
    
    
    /** 
     * Creates new GUI form 
     * @param theCyclop a reference to the Cyclop object
     */
    public CyclopGui(Cyclop theCyclop) {
        initComponents();
        refCyclop = theCyclop;
        
        // add the viewing canvas to this window
        Canvas3D mainCanvas3D = refCyclop.getMainCanvas();
        Canvas3D secondCanvas3D = refCyclop.getSecondCanvas();
        // very important, otherwise no canvas is shown
        mainCanvas3D.setSize(100,100);
        secondCanvas3D.setSize(100,100);
        
        panelModel.add(mainCanvas3D);
        panelTopview.add(secondCanvas3D);

	mainCanvas3D.addMouseListener(new java.awt.event.MouseAdapter() {
		public void mouseReleased(java.awt.event.MouseEvent evt) {
		    canvas3DMouseReleased(evt);
		}
		public void mousePressed(java.awt.event.MouseEvent evt) {
		    canvas3DMousePressed(evt);
		}
	    });
        
             
    }
    

    /** 
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        panelNavigationView = new javax.swing.JPanel();
        panelModel = new javax.swing.JPanel();
        panelNavigation = new javax.swing.JPanel();
        panelPosition = new javax.swing.JPanel();
        LblBaseDescription = new javax.swing.JLabel();
        buttonBaseLeft = new javax.swing.JButton();
        buttonBaseRight = new javax.swing.JButton();
        LblShoulderDescription = new javax.swing.JLabel();
        buttonShoulderUp = new javax.swing.JButton();
        buttonShoulderDown = new javax.swing.JButton();
        lblElbowDescription = new javax.swing.JLabel();
        buttonElbowUp = new javax.swing.JButton();
        buttonElbowDown = new javax.swing.JButton();
        lblWristTiltDescription = new javax.swing.JLabel();
        buttonTwistLeft = new javax.swing.JButton();
        buttonTwistRight = new javax.swing.JButton();
        lblWristTwistDescription = new javax.swing.JLabel();
        buttonTiltUp = new javax.swing.JButton();
        buttonTiltDown = new javax.swing.JButton();
        panelTopview = new javax.swing.JPanel();
        panelCamera = new javax.swing.JPanel();
        lblX = new javax.swing.JLabel();
        lblY = new javax.swing.JLabel();
        lblZ = new javax.swing.JLabel();
        sliderY = new javax.swing.JSlider();
        sliderZ = new javax.swing.JSlider();
        sliderX = new javax.swing.JSlider();
        panelStatus = new javax.swing.JPanel();
        lblBase = new javax.swing.JLabel();
        lblBaseText = new javax.swing.JLabel();
        lblShoulder = new javax.swing.JLabel();
        lblShoulderText = new javax.swing.JLabel();
        lblElbow = new javax.swing.JLabel();
        lblElbowText = new javax.swing.JLabel();
        lblWristTilt = new javax.swing.JLabel();
        lblWristTiltText = new javax.swing.JLabel();
        lblWristTwist = new javax.swing.JLabel();
        lblWristTwistText = new javax.swing.JLabel();
        Menu = new javax.swing.JMenuBar();
        menuOptions = new javax.swing.JMenu();
        itemSensitivity = new javax.swing.JMenuItem();
        itemSimulation = new javax.swing.JCheckBoxMenuItem();
        itemSendinput = new javax.swing.JCheckBoxMenuItem();
        separatorOptions = new javax.swing.JSeparator();
        itemClose = new javax.swing.JMenuItem();

        setTitle("Cycloop besturing");
        setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
        setName("frameMain");
        addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                formMouseClicked(evt);
            }
        });

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        panelNavigationView.setLayout(new java.awt.BorderLayout());

        panelModel.setLayout(new java.awt.BorderLayout());

        panelModel.setBorder(new javax.swing.border.TitledBorder("Model"));
        panelModel.setPreferredSize(new java.awt.Dimension(80, 80));
        panelModel.setMinimumSize(new java.awt.Dimension(100, 100));
        panelModel.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                panelModelMouseReleased(evt);
            }
            public void mousePressed(java.awt.event.MouseEvent evt) {
                panelModelMousePressed(evt);
            }
        });

        panelNavigationView.add(panelModel, java.awt.BorderLayout.CENTER);

        panelNavigation.setLayout(new java.awt.BorderLayout());

        panelNavigation.setMinimumSize(new java.awt.Dimension(160, 360));
        panelPosition.setLayout(new java.awt.GridBagLayout());

        panelPosition.setBorder(new javax.swing.border.TitledBorder("Positioning"));
        LblBaseDescription.setText("Base");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 10;
        panelPosition.add(LblBaseDescription, gridBagConstraints);

        buttonBaseLeft.setText("Left");
        buttonBaseLeft.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonBaseLeftActionPerformed(evt);
            }
        });

        buttonBaseLeft.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                buttonBaseLeftMouseClicked(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        panelPosition.add(buttonBaseLeft, gridBagConstraints);

        buttonBaseRight.setText("Right");
        buttonBaseRight.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonBaseRightActionPerformed(evt);
            }
        });

        buttonBaseRight.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                buttonBaseRightMouseClicked(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        panelPosition.add(buttonBaseRight, gridBagConstraints);

        LblShoulderDescription.setText("Shoulder");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 10;
        gridBagConstraints.insets = new java.awt.Insets(3, 0, 0, 0);
        panelPosition.add(LblShoulderDescription, gridBagConstraints);

        buttonShoulderUp.setText("Up");
        buttonShoulderUp.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                buttonShoulderUpMouseClicked(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        panelPosition.add(buttonShoulderUp, gridBagConstraints);

        buttonShoulderDown.setText("Down");
        buttonShoulderDown.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                buttonShoulderDownMouseClicked(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        panelPosition.add(buttonShoulderDown, gridBagConstraints);

        lblElbowDescription.setText("Elbow");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 10;
        gridBagConstraints.insets = new java.awt.Insets(3, 0, 0, 0);
        panelPosition.add(lblElbowDescription, gridBagConstraints);

        buttonElbowUp.setText("Up");
        buttonElbowUp.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                buttonElbowUpMouseClicked(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        panelPosition.add(buttonElbowUp, gridBagConstraints);

        buttonElbowDown.setText("Down");
        buttonElbowDown.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                buttonElbowDownMouseClicked(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        panelPosition.add(buttonElbowDown, gridBagConstraints);

        lblWristTiltDescription.setText("WristTilt");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 0, 0, 0);
        panelPosition.add(lblWristTiltDescription, gridBagConstraints);

        buttonTwistLeft.setText("Left");
        buttonTwistLeft.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                buttonTwistLeftMouseClicked(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        panelPosition.add(buttonTwistLeft, gridBagConstraints);

        buttonTwistRight.setText("Right");
        buttonTwistRight.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                buttonTwistRightMouseClicked(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 9;
        panelPosition.add(buttonTwistRight, gridBagConstraints);

        lblWristTwistDescription.setText("WristTwist");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 0, 0, 0);
        panelPosition.add(lblWristTwistDescription, gridBagConstraints);

        buttonTiltUp.setText("Up");
        buttonTiltUp.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                buttonTiltUpMouseClicked(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        panelPosition.add(buttonTiltUp, gridBagConstraints);

        buttonTiltDown.setText("Down");
        buttonTiltDown.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                buttonTiltDownMouseClicked(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        panelPosition.add(buttonTiltDown, gridBagConstraints);

        panelNavigation.add(panelPosition, java.awt.BorderLayout.NORTH);

        panelTopview.setLayout(new java.awt.BorderLayout());

        panelTopview.setBorder(new javax.swing.border.TitledBorder("Top view"));
        panelNavigation.add(panelTopview, java.awt.BorderLayout.CENTER);

        panelCamera.setLayout(new java.awt.GridBagLayout());

        panelCamera.setBorder(new javax.swing.border.TitledBorder("Camera position"));
        lblX.setText("X:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(0, 3, 0, 3);
        panelCamera.add(lblX, gridBagConstraints);

        lblY.setText("Y:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.insets = new java.awt.Insets(3, 0, 3, 0);
        panelCamera.add(lblY, gridBagConstraints);

        lblZ.setText("Z:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.insets = new java.awt.Insets(3, 0, 3, 0);
        panelCamera.add(lblZ, gridBagConstraints);

        sliderY.setMinimum(-100);
        sliderY.setValue(0);
        sliderY.setPreferredSize(new java.awt.Dimension(120, 16));
        sliderY.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                sliderYStateChanged(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        panelCamera.add(sliderY, gridBagConstraints);

        sliderZ.setMinimum(-100);
        sliderZ.setValue(0);
        sliderZ.setPreferredSize(new java.awt.Dimension(120, 16));
        sliderZ.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                sliderZStateChanged(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        panelCamera.add(sliderZ, gridBagConstraints);

        sliderX.setMinimum(-200);
        sliderX.setMaximum(200);
        sliderX.setValue(0);
        sliderX.setPreferredSize(new java.awt.Dimension(120, 16));
        sliderX.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                sliderXStateChanged(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        panelCamera.add(sliderX, gridBagConstraints);

        panelNavigation.add(panelCamera, java.awt.BorderLayout.SOUTH);

        panelNavigationView.add(panelNavigation, java.awt.BorderLayout.WEST);

        getContentPane().add(panelNavigationView, java.awt.BorderLayout.CENTER);

        panelStatus.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        panelStatus.setBorder(new javax.swing.border.TitledBorder("Status"));
        lblBase.setText("Base:");
        panelStatus.add(lblBase);

        lblBaseText.setText("angle");
        panelStatus.add(lblBaseText);

        lblShoulder.setText("Shoulder:");
        lblShoulder.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        panelStatus.add(lblShoulder);

        lblShoulderText.setText("angle");
        panelStatus.add(lblShoulderText);

        lblElbow.setText("Elbow:");
        lblElbow.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        panelStatus.add(lblElbow);

        lblElbowText.setText("angle");
        panelStatus.add(lblElbowText);

        lblWristTilt.setText("WristTilt:");
        panelStatus.add(lblWristTilt);

        lblWristTiltText.setText("angle");
        panelStatus.add(lblWristTiltText);

        lblWristTwist.setText("WristTwist:");
        panelStatus.add(lblWristTwist);

        lblWristTwistText.setText("angle");
        panelStatus.add(lblWristTwistText);

        getContentPane().add(panelStatus, java.awt.BorderLayout.SOUTH);

        menuOptions.setMnemonic('o');
        menuOptions.setText("Options");
        itemSensitivity.setMnemonic('s');
        itemSensitivity.setText("Set sensitivity...");
        itemSensitivity.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                itemSensitivityActionPerformed(evt);
            }
        });

        menuOptions.add(itemSensitivity);
        itemSimulation.setMnemonic('i');
        itemSimulation.setText("Simulation mode");
        itemSimulation.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                itemSimulationActionPerformed(evt);
            }
        });

        menuOptions.add(itemSimulation);
        itemSendinput.setMnemonic('p');
        itemSendinput.setText("Send input to robot");
        itemSendinput.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                itemSendinputActionPerformed(evt);
            }
        });

        menuOptions.add(itemSendinput);
        menuOptions.add(separatorOptions);
        itemClose.setMnemonic('c');
        itemClose.setText("Close");
        itemClose.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                itemCloseActionPerformed(evt);
            }
        });

        menuOptions.add(itemClose);
        Menu.add(menuOptions);
        setJMenuBar(Menu);

        pack();
    }//GEN-END:initComponents

    private void panelModelMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_panelModelMousePressed
        // Add your handling code here:
    }//GEN-LAST:event_panelModelMousePressed
    
    private void panelModelMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_panelModelMouseReleased
        // Add your handling code here:
    }//GEN-LAST:event_panelModelMouseReleased

   

    private void sliderXStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_sliderXStateChanged
        refCyclop.setCameraX(sliderX.getValue()/100d);
    }//GEN-LAST:event_sliderXStateChanged

    private void sliderZStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_sliderZStateChanged
        refCyclop.setCameraZ(sliderZ.getValue()/100d);
        refCyclop.setCameraX(sliderX.getValue()/100d);
    }//GEN-LAST:event_sliderZStateChanged

    private void sliderYStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_sliderYStateChanged
        refCyclop.setCameraY(sliderY.getValue()/100d);
    }//GEN-LAST:event_sliderYStateChanged

    private void itemSendinputActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_itemSendinputActionPerformed
        // Add your handling code here:
        refCyclop.setSendinputMode(!refCyclop.getSendinputMode());
    }//GEN-LAST:event_itemSendinputActionPerformed

    private void itemSimulationActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_itemSimulationActionPerformed
        // Add your handling code here:
        refCyclop.setSimulationMode(!refCyclop.getSimulationMode());
    }//GEN-LAST:event_itemSimulationActionPerformed
    
    private void itemSensitivityActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_itemSensitivityActionPerformed
        int temp = 0;
        
        while (!(temp <= 10 && temp >= 1)) {
            try {
                String input = JOptionPane.showInputDialog(null, "Please enter a sensitivity degree (1-10)", "Cycloop", JOptionPane.QUESTION_MESSAGE );
                temp = Integer.parseInt(input);
                refCyclop.setSensitivity(temp);
            } catch (Exception e) {
                // on error, keep old value & exit loop
                temp = 1;
            }
        }
                
        
    }//GEN-LAST:event_itemSensitivityActionPerformed
    
    private void buttonBaseRightActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonBaseRightActionPerformed
        // Add your handling code here:
    }//GEN-LAST:event_buttonBaseRightActionPerformed
    
    private void itemCloseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_itemCloseActionPerformed
        // Add your handling code here:
        refCyclop.closeJoystick();
        System.exit(0);
    }//GEN-LAST:event_itemCloseActionPerformed
    
    private void buttonTiltDownMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_buttonTiltDownMouseClicked
        refCyclop.checkWristTilt(-0.1, false);
    }//GEN-LAST:event_buttonTiltDownMouseClicked
    
    private void buttonTiltUpMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_buttonTiltUpMouseClicked
        refCyclop.checkWristTilt(0.1, false);
    }//GEN-LAST:event_buttonTiltUpMouseClicked
    
    private void buttonTwistRightMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_buttonTwistRightMouseClicked
        refCyclop.checkWristTwist(0.1, false);
    }//GEN-LAST:event_buttonTwistRightMouseClicked
    
    private void buttonTwistLeftMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_buttonTwistLeftMouseClicked
        refCyclop.checkWristTwist(-0.1, false);
    }//GEN-LAST:event_buttonTwistLeftMouseClicked
    
    private void buttonElbowDownMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_buttonElbowDownMouseClicked
        refCyclop.checkElbowRotate(-0.1, false);
    }//GEN-LAST:event_buttonElbowDownMouseClicked
    
    private void buttonElbowUpMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_buttonElbowUpMouseClicked
        refCyclop.checkElbowRotate(0.1, false);
    }//GEN-LAST:event_buttonElbowUpMouseClicked
    
    private void buttonShoulderDownMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_buttonShoulderDownMouseClicked
        refCyclop.checkShoulderRotate(-0.1, false);
    }//GEN-LAST:event_buttonShoulderDownMouseClicked
    
    private void buttonShoulderUpMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_buttonShoulderUpMouseClicked
        refCyclop.checkShoulderRotate(0.1, false);
    }//GEN-LAST:event_buttonShoulderUpMouseClicked
    
    private void buttonBaseRightMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_buttonBaseRightMouseClicked
        refCyclop.checkBaseRotate(0.1, false);
    }//GEN-LAST:event_buttonBaseRightMouseClicked
    
    private void buttonBaseLeftMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_buttonBaseLeftMouseClicked
        refCyclop.checkBaseRotate(-0.1, false);
    }//GEN-LAST:event_buttonBaseLeftMouseClicked
    
    private void buttonBaseLeftActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonBaseLeftActionPerformed
        // Add your handling code here:
    }//GEN-LAST:event_buttonBaseLeftActionPerformed
    
    
    private void formMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMouseClicked
        // add your code here
    }//GEN-LAST:event_formMouseClicked
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        refCyclop.exit();
        System.exit(0);
    }//GEN-LAST:event_exitForm
    
    // return an angle with at most 4 decimals
    private String labelString (String in) {
        int dotPosition = in.indexOf(".");
        if (dotPosition+DECNR < in.length()) 
            return in.substring(0,dotPosition+DECNR);
        else
            return in;
    }
    
    /**
     * Changes the Base angle label in the GUI's status bar.
     * @param angle the angle to display
     */
    public void setBaseLabel(double angle) {
        String out = Double.toString(angle);
        lblBaseText.setText(labelString(out));
    }
    
    /**
     * Changes the Shoulder angle label in the GUI's status bar.
     * @param angle the angle to display
     */
    public void setShoulderLabel(double angle) {
        String out = Double.toString(angle);
        lblShoulderText.setText(labelString(out));
    }
    
    /**
     * Changes the Elbow angle label in the GUI's status bar.
     * @param angle the Elbow angle to display
     */
    public void setElbowLabel(double angle) {
        String out = Double.toString(angle);
        lblElbowText.setText(labelString(out));
    }
    
    /**
     * Changes the Wrist Tilt angle label in the GUI's status bar.
     * @param angle the Elbow angle to display
     */
    public void setWristTiltLabel(double angle) {
        String out = Double.toString(angle);
        lblWristTiltText.setText(labelString(out));
    }
    
    /**
     * Changes the Wrist Twist angle label in the GUI's status bar.
     * @param angle the Elbow angle to display
     */
    public void setWristTwistLabel(double angle) {
        String out = Double.toString(angle);
        lblWristTwistText.setText(labelString(out));
    }

    
    // hand cursor when drag-and-dropping
    private void canvas3DMouseReleased(java.awt.event.MouseEvent evt) {
        setCursor(defaultCursor);
    }
    
    private void canvas3DMousePressed(java.awt.event.MouseEvent evt) {
        setCursor(handCursor);
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton buttonTiltDown;
    private javax.swing.JLabel LblBaseDescription;
    private javax.swing.JPanel panelNavigationView;
    private javax.swing.JPanel panelPosition;
    private javax.swing.JMenuBar Menu;
    private javax.swing.JLabel lblShoulder;
    private javax.swing.JButton buttonElbowUp;
    private javax.swing.JButton buttonTwistLeft;
    private javax.swing.JLabel lblWristTwistText;
    private javax.swing.JLabel lblElbowDescription;
    private javax.swing.JButton buttonTwistRight;
    private javax.swing.JLabel lblShoulderText;
    private javax.swing.JPanel panelModel;
    private javax.swing.JButton buttonShoulderUp;
    private javax.swing.JLabel lblWristTilt;
    private javax.swing.JLabel LblShoulderDescription;
    private javax.swing.JLabel lblElbow;
    private javax.swing.JLabel lblWristTwist;
    private javax.swing.JButton buttonBaseLeft;
    private javax.swing.JCheckBoxMenuItem itemSendinput;
    private javax.swing.JMenuItem itemSensitivity;
    private javax.swing.JMenuItem itemClose;
    private javax.swing.JPanel panelTopview;
    private javax.swing.JLabel lblWristTiltText;
    private javax.swing.JLabel lblBaseText;
    private javax.swing.JSlider sliderZ;
    private javax.swing.JSeparator separatorOptions;
    private javax.swing.JSlider sliderY;
    private javax.swing.JSlider sliderX;
    private javax.swing.JButton buttonBaseRight;
    private javax.swing.JButton buttonTiltUp;
    private javax.swing.JPanel panelNavigation;
    private javax.swing.JMenu menuOptions;
    private javax.swing.JPanel panelStatus;
    private javax.swing.JLabel lblZ;
    private javax.swing.JLabel lblWristTwistDescription;
    private javax.swing.JLabel lblY;
    private javax.swing.JPanel panelCamera;
    private javax.swing.JLabel lblX;
    private javax.swing.JButton buttonShoulderDown;
    private javax.swing.JLabel lblBase;
    private javax.swing.JLabel lblWristTiltDescription;
    private javax.swing.JLabel lblElbowText;
    private javax.swing.JCheckBoxMenuItem itemSimulation;
    private javax.swing.JButton buttonElbowDown;
    // End of variables declaration//GEN-END:variables
    
}
